option explicit
option default none
option base 0

CLS

DIM INTEGER y=0,z,x,layer=0
DIM FLOAT Q(4), yaw=0, pitch=0, roll=0
const camerax=200, cameray=mm.vres-2, viewplane=800
dim integer nv=8, nf=6 ' cube has 8 vertices and 6 faces
const camera1 = 1
dim float vertices(2,7) = (-1,1,-1,  1,1,-1,  1,-1,-1,  -1,-1,-1,  -1,1,1,  1,1,1,  1,-1,1,  -1,-1,1) 'define the vertices of the cube
dim integer fc(5)=(4,4,4,4,4,4) ' define the number of vertices in each face
dim integer faces(23)=(0,1,2,3,  1,5,6,2,  0,4,5,1,  5,4,7,6,  2,6,7,3, 0,3,7,4) 'define the vertices that make up each face
dim integer colours(6)=(rgb(blue), rgb(green), rgb(magenta), rgb(cyan), rgb(red), rgb(brown), rgb(yellow)) 'define our colour palette
dim integer edge(5)=(6,6,6,6,6,6) 'define the colours used for the edges of each face
dim integer fill(5)=(0,1,2,3,4,5) 'define the colours used to fill each face

' position of bricks
dim float posx0(10)=(1040,1135,1230,1320,1375,1395,1375,1320,1230,1135,1040)
dim float posy0(10)=( 650, 650, 630, 575, 495, 400, 305, 225, 170, 150, 150)
'                      5    4    3    2    1    1    2    3    4    5
dim float posx1(10)=(1090,1185,1275,1355,1390,1390,1355,1275,1185,1090,   0)
dim float posy1(10)=( 650, 640, 600, 535, 450, 350, 265, 200, 160, 150,   0)

' angles of bricks
dim float ang0(10)=(0,0,2,4,6,8,10,12,14,16,16)    ' times 11.25 to get degrees
math scale ang0(),rad(11.25),ang0()
dim float ang1(10)=( 0,1,3,5,7,9,11,13,15,16,16)   ' times 11.25 to get degrees
math scale ang1(),rad(11.25),ang1()

' resize brick to be 40x20x20
MATH SCALE vertices(), 20, vertices()
DIM FLOAT slice(7)
MATH SLICE vertices(),2,,slice()
MATH SCALE slice(),2,slice()  'rescale the x dimension by 2
MATH INSERT vertices(),2,,slice()

DIM INTEGER i,j
FOR i = 1 TO 11
  DRAW3D CREATE i, nv, nf, camera1, vertices(), fc(), faces(), colours(), edge(), fill()
  DRAW3D CREATE i+22, nv, nf, camera1, vertices(), fc(), faces(), colours(), edge(), fill()
  DRAW3D CREATE i+44, nv, nf, camera1, vertices(), fc(), faces(), colours(), edge(), fill()
  MATH Q_EULER ang0(i-1),0,0,q()
  DRAW3D ROTATE q(),i
  DRAW3D ROTATE q(),i+22
  DRAW3D ROTATE q(),i+44
NEXT i
FOR i = 1 TO 11
  DRAW3D CREATE i+11, nv, nf, camera1, vertices(), fc(), faces(), colours(), edge(), fill()
  DRAW3D CREATE i+33, nv, nf, camera1, vertices(), fc(), faces(), colours(), edge(), fill()
  DRAW3D CREATE i+55, nv, nf, camera1, vertices(), fc(), faces(), colours(), edge(), fill()
  MATH Q_EULER ang1(i-1),0,0,q()
  DRAW3D ROTATE q(),i+11
  DRAW3D ROTATE q(),i+33
  DRAW3D ROTATE q(),i+55
NEXT i

DRAW3D CAMERA 1, viewplane, camerax, cameray

FOR j = 0 to 2
  FOR i = 1 to 11  ' 11 bricks on even course
    DRAW3D SHOW j*22+i, posy0(i-1),j*96,posx0(i-1)
    pause 250
  NEXT i
  FOR i = 1 to 10  ' 10 bricks on odd course
    DRAW3D SHOW j*22+i+11, posy1(i-1),j*96+48,posx1(i-1)
    pause 250
  NEXT i
NEXT j
